/*
 * 拉新明细
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class PullNewDetailController : BaseController
    {
        public PullNewDetailController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 拉新明细列表

        /// <summary>
        /// 根据条件查询拉新明细列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(PullNewDetail data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 根据条件查询拉新明细列表

        /// <summary>
        /// 拉新明细列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(PullNewDetail data, string UserIdMakerCode, string UserIdRealName, string RecUserIdRealName, string RecUserIdMakerCode, string RecMallBrandIdSelect, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }
            //招募人真实姓名
            if (!string.IsNullOrEmpty(RecUserIdRealName))
            {
                condition += " and RecUserId in (select RecUserId from UserForRealName where RealName='" + RecUserIdRealName + "')";
            }
            //招募人创客编号
            if (!string.IsNullOrEmpty(RecUserIdMakerCode))
            {
                condition += " and RecUserId in (select RecUserId from UserForMakerCode where MakerCode='" + RecUserIdMakerCode + "')";
            }
            //招募人商城订单品牌
            if (!string.IsNullOrEmpty(RecMallBrandIdSelect))
            {
                condition += " and RecMallBrandId=" + RecMallBrandIdSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("PullNewDetail", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");
                //招募人
                int RecUserId = int.Parse(function.CheckInt(dic["RecUserId"].ToString()));
                Users recuserid_Users = db.Users.FirstOrDefault(m => m.Id == RecUserId) ?? new Users();
                dic["RecUserIdRealName"] = recuserid_Users.RealName;
                dic["RecUserIdMakerCode"] = recuserid_Users.MakerCode;
                dic["RecUserIdMobile"] = recuserid_Users.Mobile;
                dic["RecUserIdCertId"] = recuserid_Users.CertId;
                dic.Remove("RecUserId");
                //招募人商城订单品牌
                dic["RecMallBrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["RecMallBrandId"].ToString()));
                //商户创客类型
                int RecUserType = int.Parse(dic["RecUserType"].ToString());
                if (RecUserType == 0) dic["RecUserType"] = "非商户型合伙人";
                if (RecUserType == 1) dic["RecUserType"] = "商户型合伙人";

            }
            return Json(obj);
        }

        #endregion

        #region 增加拉新明细

        /// <summary>
        /// 增加或修改拉新明细信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加拉新明细

        /// <summary>
        /// 增加或修改拉新明细信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(PullNewDetail data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("PullNewDetail", Fields, 0);
            AddSysLog(data.Id.ToString(), "PullNewDetail", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改拉新明细

        /// <summary>
        /// 增加或修改拉新明细信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            PullNewDetail editData = db.PullNewDetail.FirstOrDefault(m => m.Id == Id) ?? new PullNewDetail();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改拉新明细

        /// <summary>
        /// 增加或修改拉新明细信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(PullNewDetail data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PullNewDetail", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "PullNewDetail", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除拉新明细信息

        /// <summary>
        /// 删除拉新明细信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "PullNewDetail", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PullNewDetail", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "PullNewDetail", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PullNewDetail", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "PullNewDetail", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("PullNewDetail", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("PullNewDetail", Sort, Id);

            AddSysLog(Id.ToString(), "PullNewDetail", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.PullNewDetail.Add(new PullNewDetail()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "PullNewDetail", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(PullNewDetail data, string UserIdMakerCode, string UserIdRealName, string RecUserIdRealName, string RecUserIdMakerCode, string RecMallBrandIdSelect)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("CreateDate", "3"); //时间


            string condition = " and Status>-1";
            //创客编号
            if (!string.IsNullOrEmpty(UserIdMakerCode))
            {
                condition += " and UserId in (select UserId from UserForMakerCode where MakerCode='" + UserIdMakerCode + "')";
            }
            //创客真实姓名
            if (!string.IsNullOrEmpty(UserIdRealName))
            {
                condition += " and UserId in (select UserId from UserForRealName where RealName='" + UserIdRealName + "')";
            }
            //招募人真实姓名
            if (!string.IsNullOrEmpty(RecUserIdRealName))
            {
                condition += " and RecUserId in (select RecUserId from UserForRealName where RealName='" + RecUserIdRealName + "')";
            }
            //招募人创客编号
            if (!string.IsNullOrEmpty(RecUserIdMakerCode))
            {
                condition += " and RecUserId in (select RecUserId from UserForMakerCode where MakerCode='" + RecUserIdMakerCode + "')";
            }
            //招募人商城订单品牌
            if (!string.IsNullOrEmpty(RecMallBrandIdSelect))
            {
                condition += " and RecMallBrandId=" + RecMallBrandIdSelect;
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("PullNewDetail", Fields, "Id desc", "0", 1, 20000, condition, "StatDate,UserId,RecUserId,RecMallOrderTime,RecMallBrandId,RecUserType,RegDate", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //创客
                int UserId = int.Parse(function.CheckInt(dic["UserId"].ToString()));
                Users userid_Users = db.Users.FirstOrDefault(m => m.Id == UserId) ?? new Users();
                dic["UserIdMakerCode"] = userid_Users.MakerCode;
                dic["UserIdRealName"] = userid_Users.RealName;
                dic.Remove("UserId");
                //招募人
                int RecUserId = int.Parse(function.CheckInt(dic["RecUserId"].ToString()));
                Users recuserid_Users = db.Users.FirstOrDefault(m => m.Id == RecUserId) ?? new Users();
                dic["RecUserIdRealName"] = recuserid_Users.RealName;
                dic["RecUserIdMakerCode"] = recuserid_Users.MakerCode;
                dic["RecUserIdMobile"] = recuserid_Users.Mobile;
                dic["RecUserIdCertId"] = recuserid_Users.CertId;
                dic.Remove("RecUserId");
                //招募人商城订单品牌
                dic["RecMallBrandId"] = RelationClass.GetKqProductBrandInfo(int.Parse(dic["RecMallBrandId"].ToString()));
                //商户创客类型
                int RecUserType = int.Parse(dic["RecUserType"].ToString());
                if (RecUserType == 0) dic["RecUserType"] = "非商户型合伙人";
                if (RecUserType == 1) dic["RecUserType"] = "商户型合伙人";

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("UserIdMakerCode", "创客编号");
            ReturnFields.Add("UserIdRealName", "创客姓名");
            ReturnFields.Add("StatDate", "拉新达标日期");
            ReturnFields.Add("RecMallBrandId", "达标条件");
            ReturnFields.Add("RecUserIdRealName", "新创客姓名");
            ReturnFields.Add("RecUserIdMakerCode", "新创客编号");
            ReturnFields.Add("RecUserIdMobile", "新创客手机号");
            ReturnFields.Add("RecUserIdCertId", "身份证号");
            ReturnFields.Add("RecUserType", "商户创客类型");
            ReturnFields.Add("RegDate", "注册时间");
            ReturnFields.Add("RecMallOrderTime", "商城下单时间");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "PullNewDetail", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
